!
!= Ωѿ () κ
!
! Authors::   Yasuhiro MORIKAWA, Eizi TOYODA
! Version::   $Id: gtvarcreated.f90,v 1.4 2006/01/15 16:52:41 morikawa Exp $
! Tag Name::  $Name: gt4f90io-20060121 $
! Copyright:: Copyright (C) GFD Dennou Club, 2000-2005. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
! ʲΥ֥롼, ؿ gtdata_generic 󶡤ޤ
!

subroutine GTVarCreateD(var, url, length, xtype, long_name, overwrite, err)
  !
  !== Ωѿ () κ
  !
  !  *url* Ĺ *length* μʬȤ򼡸ȤѿĤޤ GT_VARIABLE 
  ! μΤ 1  *var* ˥åȤޤ
  ! Open 줿ΤƱ͡1 *var* ϸɬ
  ! Close ʤФʤޤ
  !
  ! Ĺ length == 0 ꤹȤѿϲĹȤʤޤ
  !  *xtype* ά "+float+" 
  ! ߤʤޤ¸ѿȤԤޤ
  ! overwrite == .true. Ǥо񤭤³Ԥޤ
  ! (ޤ *overwrite* ưݾ㤵Ƥޤ)
  ! dims ξά 0 ѿ̣ޤ
  !
  ! ѿϼư뤳Ȥ¿ᡢѿ̾礯ФƤ
  ! ̾ưޤ
  !
  ! κݤ˥顼硢åϤƥץ
  ! λޤ*err* ͿƤˤϤΰ .true.
  ! ֤ꡢץϽλޤ
  !
  use dc_string, only: StrHead
  use gtdata_types, only: GT_VARIABLE
  use gtdata_generic, only: GtDataTmpNam
  use an_generic, only: Create, Put_Attr, an_variable
  use gt_mem, only: Create, mem_variable
  use gt_map, only: map_create, vtb_class_memory, vtb_class_netcdf, gtvar_dump
  use dc_url, only: UrlSplit, UrlMerge
  use dc_trace, only: beginsub, endsub, DbgMessage
  use dc_types, only: STRING
  implicit none
  type(GT_VARIABLE), intent(out):: var
  character(len = *), intent(in):: url
  integer, intent(in):: length
  character(len = *), intent(in), optional:: xtype
  character(len = *), intent(in), optional:: long_name
  logical, intent(in), optional:: overwrite
  logical, intent(out), optional:: err
  character(len = STRING):: fnam, vnam, new_url
  type(an_variable):: an
  type(mem_variable):: mem
continue
  call beginsub('gtvarcreate-d', 'url=<%c> length=%d', c1=trim(url), i=(/length/))
  if (strHead(url, "memory:")) then
    call Create(mem, url, length, xtype, long_name, overwrite, err)
    call map_create(var, vtb_class_memory, mem%id, 1, (/length/))
    call gtvar_dump(var)
    call endsub('gtvarcreate-d', 'class=memory mapid=%d', i=(/var%mapid/))
    return
  endif
  ! URL θ
  call UrlSplit(url, file=fnam, var=vnam)
  if (vnam == "") then
    call GtDataTmpNam(file=fnam, base="dim", result=new_url)
  else
    new_url = url
  endif
  ! an 򤵤
  call Create(var=an, url=new_url, length=length, xtype=xtype, &
    & overwrite=overwrite, err=err)
  if (present(long_name)) then
    call put_attr(an, 'long_name', long_name, err=err)
  endif
  call map_create(var, vtb_class_netcdf, an%id, 1, (/length/))
  call gtvar_dump(var)
  call endsub('gtvarcreate-d', 'class=netcdf mapid=%d', i=(/var%mapid/))
end subroutine GTVarCreateD
